# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#


%global namedreltag .CR5
%global namedversion %{version}%{?namedreltag}

Name:           jboss-profiler
Version:        1.0.0
Release:        %mkrel 0.1.%{namedversion}.7
Epoch:          0
Summary:        Log based profiler using JVMPI and JVMTI
License:        LGPLv2+
Group:          Development/Java
URL:            http://labs.jboss.com/portal/jbossprofiler
# cvs -z3 -d:pserver:anonymous@anoncvs.forge.jboss.com:/cvsroot/jboss export -r JBPROFILER_CR5 -d jboss-profiler-1.0.0.CR5 jboss-profiler && tar cjf jboss-profiler-1.0.0.CR5.tar.bz2 jboss-profiler-1.0.0.CR5
Source0:        jboss-profiler-%{namedversion}.tar.bz2
Source1:        https://maven.nuxeo.org/nexus/content/repositories/public/jboss/profiler/jvmti/jboss-profiler-jvmti/%{namedversion}/jboss-profiler-jvmti-%{namedversion}.pom

Patch0:         jboss-profiler-ChartView.patch
Patch1:         jboss-profiler-ServletUpload.patch
Patch2:         jboss-profiler-ServletUploadFile.patch
Patch3:         jboss-profiler-GraphApplet.patch
Patch4:         jboss-profiler-GraphMemoryApplet.patch
Patch5:         jboss-profiler-project_properties.patch
Patch6:         jboss-profiler-jfreechart-StandardPieToolTipGenerator.patch
# remove com.sun.image.codec.jpeg.JPEGImageEncoder
Patch7:         jboss-profiler-1.0.0.CR5-ChartView.patch

BuildRequires:  java-devel
BuildRequires:  jpackage-utils

BuildRequires:  ant 
BuildRequires:  ant-junit
BuildRequires:  apache-commons-beanutils
BuildRequires:  apache-commons-fileupload
BuildRequires:  gnu-trove >= 2.1.0
BuildRequires:  jakarta-poi == 3.1
BuildRequires:  jboss-aop
BuildRequires:  jboss-common-core
BuildRequires:  jboss-logging-spi
BuildRequires:  jcommon
BuildRequires:  jfreechart
BuildRequires:  jgraph
BuildRequires:  junit
BuildRequires:  struts
BuildRequires:  tomcat6-servlet-2.5-api

Requires:       jboss-common-core
Requires:       jboss-logging-spi

Requires:       java
Requires:       jpackage-utils
BuildArch:      noarch

%description
JBoss Profiler is a log based profiler using JVMPI and JVMTI. 
It uses an agent written in C that captures events from the
JVM and logs them to disk. A web application running on JBoss
or another machine can be used to analyze these logs through a
web browser.

Using log files is especially useful for server application
analysis. Creating profiling snapshots without the need of a
front-end near the JVM means the data can be analyzed#
remotely.

Imagine if your application server slows down and you don't know
why. Why should you have to install a complex tool environment or
have to send data through an open port, breaking firewall rules
between the profiler front-end and the JVMPI/JVMTI JBoss Profiler
can be easily run though your web browser instead.

NOTE: You may have to add a few things on the classpath for running the
profiler console (jgraph, jfreechart, jcommon...).
The AS should provide what is needed for the data # collection during run-time.

%package webapps
Summary:        WARs, SARs, Applet for %{name}
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description webapps
JBoss Profiler is a log based profiler using JVMPI and JVMTI. 
It uses an agent written in C that captures events from the
JVM and logs them to disk. A web application running on JBoss
or another machine can be used to analyze these logs through a
web browser.

%package manual
Summary:        Documents for %{name}
Group:          Development/Java

%description manual
JBoss Profiler is a log based profiler using JVMPI and JVMTI. 
It uses an agent written in C that captures events from the
JVM and logs them to disk. A web application running on JBoss
or another machine can be used to analyze these logs through a
web browser.

%prep
%setup -q -n jboss-profiler-%{namedversion}
chmod -R go=u-w *
# Clean up
find . -depth -type d -name CVS -exec rm -r {} \;
find -name '*.jar' -exec rm -f '{}' \;
find -name '*.class' -exec rm -f '{}' \;
find -name '*.so' -exec rm -f '{}' \;
find -name '*.jnilib' -exec rm -f '{}' \;
find -name '*.dll' -exec rm -f '{}' \;
find -name '*.exe' -exec rm -f '{}' \;
find -name '*.bat' -exec rm -f '{}' \;

perl -pi -e 's/\r$//g' docs/wiki/JBossProfilerDocumentation.wiki docs/Tutorials/readme.txt

%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2
%patch3 -p0 -b .sav3
%patch4 -p0 -b .sav4
%patch5 -p0 -b .sav5
%patch6 -p1 -b .sav6a

%patch7 -p0

pushd java/libs/aop
  ln -s $(build-classpath jboss-aop/jboss-aop) .
  ln -s $(build-classpath jboss/jboss-logging-spi) .
  ln -s $(build-classpath jboss/jboss-common-core) .
  ln -s $(build-classpath gnu-trove) .
popd
pushd java/libs/web
  ln -s $(build-classpath struts/core) .
  ln -s $(build-classpath tomcat6-servlet-api) .
  ln -s $(build-classpath commons-fileupload) .
  ln -s $(build-classpath commons-beanutils) .
  ln -s $(build-classpath jakarta-poi) .
  ln -s $(build-classpath jfreechart/jfreechart) .
  ln -s $(build-classpath jcommon) .
popd
pushd java/libs/appletsLibs
  ln -s $(build-classpath jgraph) .
popd

%build
export CLASSPATH=
export OPT_JAR_LIST=`cat %{_sysconfdir}/ant.d/junit`
%{ant} \
        compile \
        jar \
        war \
        console \
        jboss-mbean \
        javah-full \
        javah-lite \
        antProfiler \
        appletjar

%install

# jar
mkdir -p %{buildroot}%{_javadir}/%{name}
install -pm 644 build/antProfiler.jar %{buildroot}%{_javadir}/%{name}/antProfiler.jar
install -pm 644 build/jar/%{name}Engine.jar %{buildroot}%{_javadir}/%{name}/%{name}Engine.jar
install -pm 644 build/%{name}-jvmti.jar %{buildroot}%{_javadir}/%{name}/%{name}-jvmti.jar
install -pm 644 build/profilerConsole.jar %{buildroot}%{_javadir}/%{name}/profilerConsole.jar
install -pm 644 build/profilerSynchronizer.jar %{buildroot}%{_javadir}/%{name}/profilerSynchronizer.jar

# pom
mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 %{SOURCE1} %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-jvmti.pom
%add_maven_depmap JPP.%{name}-%{name}-jvmti.pom %{name}/%{name}-jvmti.jar

# webapps
mkdir -p %{buildroot}%{_datadir}/%{name}
install -pm 644 build/aop-monitoring.war %{buildroot}%{_datadir}/%{name}
install -pm 644 build/applet/graphApplet.jar %{buildroot}%{_datadir}/%{name}
install -pm 644 build/jboss-profiler-jvmti.sar %{buildroot}%{_datadir}/%{name}
install -pm 644 build/jboss-profiler-noAOP.sar %{buildroot}%{_datadir}/%{name}
install -pm 644 build/jboss-profiler.war %{buildroot}%{_datadir}/%{name}

# manual
mkdir -p %{buildroot}%{_docdir}/%{name}
mv "docs/JBossProfiler - JVMTI.doc" "docs/JBossProfiler-JVMTI.doc"
mv "docs/JBoss Profiler ARM.doc" "docs/JBossProfilerARM.doc"
cp -pr docs/* %{buildroot}%{_docdir}/%{name}


%files
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/antProfiler.jar
%{_javadir}/%{name}/%{name}-jvmti.jar
%{_javadir}/%{name}/%{name}Engine.jar
%{_javadir}/%{name}/profilerConsole.jar
%{_javadir}/%{name}/profilerSynchronizer.jar
%{_mavenpomdir}/JPP.%{name}-%{name}-jvmti.pom
%{_mavendepmapfragdir}/%{name}

%files webapps
%{_datadir}/%{name}

%files manual
%{_docdir}/%{name}



%changelog

* Sat Mar 03 2012 gil <gil> 0:1.0.0-0.1.1.0.0.CR5.7.mga2
+ Revision: 217006
- fix jakarta-poi version
- fix jakarta-poi link
- imported package jboss-profiler


* Sat Feb 04 2012 gil <gil>  0:1.0.0-0.1.CR5.7
- imported
- adapt to current guideline
- remove sun jpeg codec (P7)

* Tue Jan 18 2011 Will Tatam <will.tatam@red61.com> 0:1.0.0-0.1.CR5.6
- JPP6 rebuild 

* Wed Sep 23 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-0.1.CR5.5
- add pom
- fix install

* Wed Jun 17 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-0.1.CR5.4
- build for JPP-6

* Wed Oct 08 2008 David Walluck <dwalluck@redhat.com> 0:1.0-0.1.CR5.3
- fix component-info.xml
- fix repolib permissions
- fix repolib file ownership

* Mon Jun 02 2008 David Walluck <dwalluck@redhat.com> 0:1.0-0.1.CR5.2.jpp5
- fix License
- fix file permissions
- fix file eol

* Mon Apr 21 2008 David Walluck <dwalluck@redhat.com> 0:1.0-0.1.CR5.1jpp.ep1.3
- allow build with newer jfrechart

* Wed Jun 27 2007 Fernando Nasser <fnasser@redhat.com> 0:1.0-0.1.CR5.1jpp.ep1.2
- Relax run-time dependencies

* Mon Jun 25 2007 Fernando Nasser <fnasser@redhat.com> 0:1.0-0.1.CR5.1jpp.ep1.1
- Use upstream version because we need profilerConsole.jar for jboss-serialization
- Use plain jfreechart and jcommon as our versions are older than the upstream ones

* Mon Jun 25 2007 Fernando Nasser <fnasser@redhat.com> 0:1.0-0.1.CR5.1jpp
- Upgrade to CR5
- Has to use legacy jfreechart0 (and jcommon0) due to API changes

* Tue Mar 13 2007 Fernando Nasser <fnasser at redhat.com> - 1.0-0.1.CR5.0jpp.ep1.1
- New repolib location

* Thu Feb 22 2007 Vivek Lakshmanan <vivekl at redhat.com> - 1.0-0.CR5.el4ep1.1
- First build for JBoss AS 4.2 - very temporary solution

* Thu Nov 2 2006 Matt Wringe <mwringe at redhat.com> - 0.0-0jpp
- Initial rpm build

* Wed Jun 07 2006 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.rc2.1jpp
- First JPP-1.7 release
